//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
vw.label = {


//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//***
//***draw mailing labels
//***
//////////////////////////////////////////////////////////////////////////////
drawMailLabels: function (control, labelType, cData, prop, inchUnit) {
//------------------------------
//control; control
//labelType; 1 = 1'' x 2 5/8''
//           2 = 2 1/2'' x 3 3/8''
//           3 = 1 1/2'' x 4''
//           4 = 2 3/4'' x 2 3/4''
//cData - data array
//prop - properteis
//------------------------------

var conlabelTypes = 4;
var INCH = inchUnit;
              
//-----
//Working variables
var i, j, k;
var x, y;
var nLabel, nPage, nLabelTotal;
var sTemp;

//-----
//Specify label attributes
//Array(1 To conlabelTypes)
var labelRow = new Array(); //Number of label rows
var labelCol = new Array(); //Number of label columns
var labelW = new Array();  //Label width
var labelH = new Array();  //Label height
var labelMarginX = new Array(); //Label margin from left paper edge
var labelMarginY = new Array(); //Label margin from top paper edge
var labelDX = new Array();     //Horz distance betwee labels
var labelDY = new Array();     //Vert distance betwee labels
var labelMarginHorz = new Array();  //Dist of text from label left edge
var labelMarginVert = new Array();  //Dist of text from label top edge

//-----
//Working variables for current label type
var RowNum;       //Number of label rows
var ColNum;       //Number of label columns
var CellWidth;    //Label width
var CellHeight;   //Label height
var marginX;      //Label margin from left paper edge
var marginY;      //Label margin from top paper edge
var DX;           //Horz distance betwee labels
var DY;           //Vert distance betwee labels


//-----
//Set label attributes
labelW[1] = 2 + 5 / 8; labelH[1] = 1;
labelW[2] = 3 + 3 / 8; labelH[2] = 2 + 1 / 2;
labelW[3] = 4; labelH[3] = 1 + 1 / 2;
labelW[4] = 2 + 3 / 4; labelH[4] = 2 + 3 / 4;

labelRow[1] = 10; labelCol[1] = 3;
labelRow[2] = 4; labelCol[2] = 2;
labelRow[3] = 7; labelCol[3] = 2;
labelRow[4] = 4; labelCol[4] = 3;

labelMarginX[1] = 3*INCH/8; labelMarginY[1] = 0.5 * INCH;
labelMarginX[2] = 0.75 * INCH; labelMarginY[2] = 0.5 * INCH;
labelMarginX[3] = 3*INCH/8; labelMarginY[3] = 0.25 * INCH;
labelMarginX[4] = INCH/16; labelMarginY[4] = 0;

labelDX[1] = INCH/8; labelDY[1] = 0;
labelDX[2] = INCH/8; labelDY[2] = 0;
labelDX[3] = INCH/8; labelDY[3] = 0;
labelDX[4] = INCH/16; labelDY[4] = 0;

labelMarginHorz[1] = 0.2 * INCH; labelMarginVert[1] = INCH/8;
labelMarginHorz[2] = 0.2 * INCH; labelMarginVert[2] = 0.5 * INCH;
labelMarginHorz[3] = 0.2 * INCH; labelMarginVert[3] = 0.25 * INCH;
labelMarginHorz[4] = 0.2 * INCH; labelMarginVert[4] = 0.75 * INCH;


//-----
//Specify attributes for current label type
RowNum = labelRow[labelType];
ColNum = labelCol[labelType];
CellWidth = labelW[labelType] * INCH;
CellHeight = labelH[labelType] * INCH;
marginX = labelMarginX[labelType];
marginY = labelMarginY[labelType];
DX = labelDX[labelType];
DY = labelDY[labelType];


	var marginHorz = labelMarginHorz[labelType];
	var marginVert = labelMarginVert[labelType];
	
    prop = vwstring.setKeyValue(prop, "marginLeft", marginHorz);
    prop = vwstring.setKeyValue(prop, "marginRight", marginHorz);
    prop = vwstring.setKeyValue(prop, "marginTop", marginVert);
    prop = vwstring.setKeyValue(prop, "marginBottom", marginVert);

        
    nPage = 1;
	nLabelTotal = (nPage - 1) * ColNum * RowNum;
    
    var prop2 = prop + ";h=" + CellHeight;
    
	var idx;
    for (nLabel = 1; nLabel<=cData.length; nLabel++) {    
			idx = nLabel - 1;
            sTemp = cData[idx];
                        
            //Check if new page needed
            if (nLabel == (nPage * ColNum * RowNum + 1) ) {
                nPage = nPage + 1;
                nLabelTotal = (nPage - 1) * ColNum * RowNum;
                control.newPage();
            }
            k = nLabel - nLabelTotal;
            
            //Get (i,j) cell position
            ////j = k \ ColNum;
            j = parseInt(k / ColNum,10);
            if (k > j * ColNum) { j = j + 1; }
            i = k - (j - 1) * ColNum;
            x = marginX + (i - 1) * (CellWidth + DX);
            y = marginY + (j - 1) * (CellHeight + DY);


            //Write label content
            //control.drawRect(x, y, CellWidth, CellHeight);
			control.drawText(x,y,CellWidth,sTemp,prop2);
    }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


};
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
